jQuery(document).ready(function () {
    jQuery('body').on('click', '#active-popup a.close', function () {
        var id = this.getAttribute("value");
        
        defaultStyle.destroyPopup(jQuery('.active-popup-'+id).find('.popup'),id, true);
    });
    
    defaultStyle.loadPopupsArray();
    //defaultStyle.showPopup();
});

var defaultStyle = new function() {
    
    this.loadPopupsArray = function()
    {
       var popups = [];
       var popup = this.getNextPopup();
       self = this;
       
        while (popup) {

            popups.push(popup);
            popup.remove();
            var popup = this.getNextPopup();
        }; 
        
        
        popups.forEach(function(item, index){
            self.loadPopup(item);
        })
        
    }
    this.loadPopup = function(popup)
    {
        var delay = popup.attr('data-popup-delay');
        var self = this;
        if(delay > 0)
        {
            setTimeout(function(){ 
                
                self.showPopup(popup); 
            }, delay*1000);
        }else{
             this.showPopup(popup); 
        }  
    }
    
    this.showPopup = function (popup) {
        //var popup = this.getNextPopup();
        if(popup === false) {
            $('#active-popup').remove();
            return false;
        }

        //popup = $('#popup-container > .popup.active-popup:nth-child(1)');
        if((typeof popup !== "undefined") && popup.length > 0) {
            var settings = this.getPopupSettings(popup);
            popup.find('.popup-attributes').remove();

            popup.removeClass('not-shown').addClass('active-popup');
            var id = popup.attr('data-popup-id');
            var html = '<div class="popup"  data-popup-id="'+id+'">'+popup.html()+'</div>';
            popup.remove();

            var pageHeight = jQuery(document).height();
            jQuery('body').prepend('<div class="active-popup-'+id+'" id="active-popup">'+html+'</div>');
            jQuery('#active-popup').css("height", pageHeight);
            var activePopup = jQuery('#active-popup .popup');
            var popupWindow = activePopup.find('.popup-window');
            activePopup.show();
            var mess = activePopup.find('.message');

            var w = (settings.width === 'auto')? mess.outerWidth(true)+1:settings.width;
            var h = (settings.height === 'auto')? mess.outerHeight(true):settings.height;
            var messer = {"height": h, "width": w};

            if(settings.width === 'auto') {
                delete messer.width;
            }

            if(settings.height === 'auto') {
                delete messer.height;
            }
            if(!jQuery.isEmptyObject(messer)){
                mess.css(messer);
            }
            
            if(activePopup.find('.notshow-container').length > 0) {
               var minwidth = $('[data-popup-id="'+id+'"]').find('.notshow-container').outerWidth(true);
               mess.css('min-width', '200px');
            }
            
            popupWindow.addClass('ready');

            $.post(location.href, { popupShowed: id } );
        }
    };

    this.getNextPopup = function () {
        
        var popup = $('#popup-container > .not-shown.popup:nth-child(1)');
        popup.removeClass('not-shown').addClass('active-popup');
        if (popup.length > 0) {
            if(this.canPopupBeShown(popup)) {
                return popup;
            }
            else
            {
                popup.remove();
            }
        } else {
            return false;
        }

        this.getNextPopup();
    };

    this.canPopupBeShown = function (popup) {
        if(this.getQuery('debug_popup') || this.getQuery('debug_styles')){
            return true;
        }
        var settings = this.getPopupSettings(popup);
        var resultDates = this.datesMatches(settings);
        if(resultDates !== true) {
            this.destroyPopup(popup,settings.id, false);
            return false;
        }
        var resultTrigger = this.triggerMatches(settings, popup);
        if(resultTrigger !== true) {
            this.destroyPopup(popup,settings.id, false);
            return false;
        }

        return true;
    }

    this.destroyPopup = function(popup,id, shown) {

        if(shown === true) {
            var notShowAgain = (popup.find('input.not-show-again:checked').length)? 1:0;
            cookie = {
                'notShowAgain': notShowAgain,
                'lastTriggered': Date.now()
            };
            this.setPopupCookie(popup, cookie);
        }
        popup.fadeOut();
        //popup.remove();
        $('.active-popup-'+id).remove();
    };

    this.datesMatches = function(settings) {    

        var tempdate = new Date(settings.start.replace(/-/g,'/'));
        var startDate = tempdate.getTime();
        var tempdate = new Date(settings.end.replace(/-/g,'/'));
        var endDate = tempdate.getTime();
        var nowDate = Date.now();

        return (nowDate > startDate && nowDate < endDate)? true:false;     
    };

    this.triggerMatches = function(settings, popup) {
        var cookie = this.getPopupCookie(popup);
        var notShowAgain = cookie.notShowAgain || 0;
        var lastTriggered = cookie.lastTriggered || false;
        var trigger = settings.trigger;

        if(notShowAgain === 1)
            return false;

        if(trigger === '-1')
            return true;

        if(lastTriggered === false)
            return true;

        var nowDate = Date.now();
        var diff = nowDate - lastTriggered;
        var minutes = diff / 1000 / 60;

        return (minutes > trigger)? true:false;
    };

    this.getPopupSettings = function(popup) {
        if(popup.find) {
            var settingsJson = popup.find('.popup-attributes').text();
            return jQuery.parseJSON(settingsJson);
        }
        return {};
    };

    this.getPopupCookie = function(popup){
        var popupId = popup.attr('data-popup-id');
        var popupCookieId = 'popup-'+popupId;
        var cookieJson = jQuery.cookie(popupCookieId) || '{}';
        var cookie = $.parseJSON(cookieJson);

        return cookie;
    };

    this.getQuery = function(q) {
        return (window.location.search.match(new RegExp('[?&]' + q + '=([^&]+)')) || [, null])[1];
    }

    this.setPopupCookie = function(popup, cookie) {
        var popupId = popup.attr('data-popup-id');
        var popupCookieId = 'popup-'+popupId;

        jQuery.cookie(popupCookieId, JSON.stringify(cookie));
    };
}
