jQuery(document).ready(function () {
    jQuery('body').on('click', '[id^=active-popup] a.close', function (event) {
        destroyPopup(jQuery(event.target).parents('.popup'), true);
    });
    
    showPopup();
});

//jQuery(document).mouseup(function (e) {
//    var container = jQuery('#active-popup');
//    if (!container.is(e.target) && container.has(e.target).length === 0){
//        destroyPopup(container.find('.popup'), true);
//    }
//
//});

var showPopup = function () {
    var popup = getNextPopup();
    if(popup === false) {
        popup.parents('[id^=active-popup]').remove();
        return false;
    }

    $('.popup-container > .popup.active-popup').each(function(e,p){
        var popup = $(p); 
        delay = popup.attr('data-popup-delay');
        if(delay > 0)
        {
            popup.parent('.popup-container').attr('hidden',true);
            setTimeout(function(){ 
                popup.parent('.popup-container').attr('hidden',false);
                displayPopup(popup); 
            }, delay*1000);
        }else{
             displayPopup(popup); 
        }  
    });
};

var displayPopup = function(popup)
{
    if((typeof popup !== "undefined") || popup.length) {
        var settings = getPopupSettings(popup);
        popup.find('.popup-attributes').remove();

        popup.removeClass('not-shown').addClass('active-popup');
        var id = popup.attr('data-popup-id');
        var html = '<div class="popup" data-popup-id="'+id+'">'+popup.html()+'</div>';
        popup.remove();
        var idStyle = '#active-popup-'+popup.attr('data-popup-style');
        
        var pageHeight = jQuery(document).height();
        jQuery('body').prepend('<div id="active-popup-'+popup.attr('data-popup-style')+'">'+html+'</div>');
        //jQuery(idStyle).css("height", pageHeight);
        var activePopup = jQuery(idStyle+' .popup');

        var popupWindow = activePopup.find('.popup-window');
        activePopup.show();
        //var mess = activePopup.find('[data-popup-id="'+id+'"]').find('.message');
        var mess = $('[data-popup-id="'+id+'"]').find('.message');


        var w = (settings.width === 'auto')? mess.outerWidth(true)+1:settings.width;
        var h = (settings.height === 'auto')? mess.outerHeight(true):settings.height;
        var messer = {"height": h, "width": w};
        
        if(settings.width === 'auto') {
            delete messer.width;
            mess.parents('.popup-window').css('max-width','50%');
        }
        
        if(settings.height === 'auto') {
            delete messer.height;
        }
        if(!jQuery.isEmptyObject(messer)){
            mess.css(messer);
        }
        
        if($('[data-popup-id="'+id+'"]').find('.notshow-container').length > 0) {
               var minwidth = $('[data-popup-id="'+id+'"]').find('.notshow-container').outerWidth(true);
               mess.css('min-width', '200px');
        }

        popupWindow.addClass('ready');
        
        $.post(location.href, { popupShowed: id } );
        }
    
}

var getNextPopup = function () {
    $('.popup-container > .not-shown.popup').each(function(e,p){
        
        var popup = $(p);
        popup.removeClass('not-shown').addClass('active-popup');
        if (popup.length > 0) {
            if(canPopupBeShown(popup)) {
                return popup;
            }
            else{
                popup.remove();
            }
        } else {
            return false;
        }
    });

    
    //getNextPopup();
};

var canPopupBeShown = function (popup) {
    
    if(getQuery('debug_popup') || getQuery('debug_styles')){
        return true;
    }
    
    var settings = getPopupSettings(popup);
    var resultDates = datesMatches(settings);
    if(resultDates !== true) {
        destroyPopup(popup, false);
        return false;
    }
    var resultTrigger = triggerMatches(settings, popup);
    if(resultTrigger !== true) {
        destroyPopup(popup, false);
        return false;
    }
    
    return true;
}

var destroyPopup = function(popup, shown) {
    if(shown === true) {
        var notShowAgain = (popup.find('input.not-show-again:checked').length)? 1:0;
        cookie = {
            'notShowAgain': notShowAgain,
            'lastTriggered': Date.now()
        };
        setPopupCookie(popup, cookie);
    }
    
    popup.fadeOut();
    //popup.remove();
    popup.parents('[id^=active-popup]').remove();
    //showPopup();
};

var datesMatches = function(settings) {    
    var tempdate = new Date(settings.start.replace(/-/g,'/'));
    var startDate = tempdate.getTime();
    var tempdate = new Date(settings.end.replace(/-/g,'/'));
    var endDate = tempdate.getTime();
    var nowDate = Date.now();
    return (nowDate > startDate && nowDate < endDate)? true:false;    
};

var triggerMatches = function(settings, popup) {
    var cookie = getPopupCookie(popup);
    var notShowAgain = cookie.notShowAgain || 0;
    var lastTriggered = cookie.lastTriggered || false;
    var trigger = settings.trigger;

    if(notShowAgain === 1)
        return false;
        
    if(trigger === '-1')
        return true;
    
    if(lastTriggered === false)
        return true;
    
    var nowDate = Date.now();
    var diff = nowDate - lastTriggered;
    var minutes = diff / 1000 / 60;
    
    return (minutes > trigger)? true:false;
};

var getPopupSettings = function(popup) {
    if(popup.find) {
        var settingsJson = popup.find('.popup-attributes').text();
        return JSON.parse(settingsJson);
    }
    return {};
};

var getPopupCookie = function(popup){
    var popupId = popup.attr('data-popup-id');
    var popupCookieId = 'popup-'+popupId;
    var cookieJson = jQuery.cookie(popupCookieId) || '{}';
    var cookie = $.parseJSON(cookieJson);
    return cookie;
};

var getQuery = function(q) {
    return (window.location.search.match(new RegExp('[?&]' + q + '=([^&]+)')) || [, null])[1];
}

var setPopupCookie = function(popup, cookie) {
    var popupId = popup.attr('data-popup-id');
    var popupCookieId = 'popup-'+popupId;
    
    jQuery.cookie(popupCookieId, JSON.stringify(cookie));
};
